HDOJ 2209 贪心

翻纸牌游戏

Time Limit: 9000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3669    Accepted Submission(s): 1371

Problem Description

有一种纸牌游戏,很有意思,给你N张纸牌,一字排开,纸牌有正反两面,开始的纸牌可能是一种乱的状态(有些朝正,有些朝反),现在你需要整理这些纸牌。但是麻烦的是,每当你翻一张纸牌(由正翻到反,或者有反翻到正)时,他左右两张纸牌(最左边和最右边的纸牌,只会影响附近一张)也必须跟着翻动,现在给你一个乱的状态,问你能否把他们整理好,使得每张纸牌都正面朝上,如果可以,最少需要多少次操作。

Input

有多个case,每个case输入一行01符号串(长度不超过20),1表示反面朝上,0表示正面朝上。

Output

对于每组case,如果可以翻,输出最少需要翻动的次数,否则输出NO。

Sample Input

01
011

Sample Output

NO
1

Author

wangye

题解:

首先有两个分支,即第一张牌翻还是不翻(它的前面没有牌,所以两种可能都要考虑),之后往后dfs,去看这张牌的前面一张牌是正面还是反面,如果是正面,那就不翻现在这张牌,否则,翻这张牌来把前面那张变成正面,变成正面后,没有其他操作会将它变回反面了,这样下去,当搜索结束之后,讨论最后一张牌,如果是正,那就这组存在解,否则,无解。

代码:

 1 #include "cstdio"
 2 #include "iostream"
 3 #include "algorithm"
 4 #include "string"
 5 #include "cstring"
 6 #include "queue"
 7 #include "cmath"
 8 #include "vector"
 9 #include "map"
10 #include "stdlib.h"
11 #include "set"
12 #define mj
13 #define db double
14 #define ll long long
15 using  namespace std;
16 const int N=1e6+5;
17 const int mod=1e9+7;
18 const ll inf=1e16+10;
19 char s[N];
20 int a[N];
21 int  dfs(int i,int n,int cnt){
22     if(i==n){//判断最后一张牌的状态
23         if(a[n-1]) return 1e8;
24         else return cnt;
25     }
26     if(a[i-1]) a[i-1]=!a[i-1],a[i]=!a[i],a[i+1]=!a[i+1],cnt++;
27     return dfs(i+1,n,cnt);
28 }
29 int main()
30 {
31     int n;
32     while(scanf("%s",s)==1){
33         int ans;
34         n=strlen(s);
35         for(int i=0;i<n;i++)
36             a[i]=s[i]-‘0‘;
37         a[0]=!a[0],a[1]=!a[1];
38         ans=dfs(1,n,1);
39         for(int i=0;i<n;i++)
40             a[i]=s[i]-‘0‘;
41         ans=min(ans,dfs(1,n,0));//取最小值
42         if(ans==1e8) printf("NO\n");
43         else printf("%d\n",ans);
44
45     }
46     return 0;
47 }
时间: 2024-11-16 06:12:11

HDOJ 2209 贪心的相关文章

hdoj 4310 贪心

不知为毛,过不了 我的代码: #include<stdio.h> int main(){ int n,a[30],b[30],temp,i,j,s1,s2; double c[30]; while(scanf("%d",&n)!=EOF) {  s1=0;  s2=0;  for(i=0;i<n;i++)  {   scanf("%d%d",&a[i],&b[i]);   s1+=a[i];   c[i]=a[i]/b[i]

hdoj 1003 Max Sum 【最大子段和】【贪心】

题意:... 策略:看着像贪心,感觉也是贪心. 很久之前做的,又做了一遍,好题. 代码: #include<stdio.h> #include<string.h> int s[100005]; int main() { int t, i, j, l, st, en, n, v = 1; scanf("%d", &t); while(t --){ scanf("%d", &n); for(i = 1; i <= n; i

HDOJ 1009. Fat Mouse&#39; Trade 贪心 结构体排序

FatMouse' Trade Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 56784    Accepted Submission(s): 19009 Problem Description FatMouse prepared M pounds of cat food, ready to trade with the cats g

贪心 HDOJ 4726 Kia&#39;s Calculation

题目传送门 1 /* 2 这题交给队友做,做了一个多小时,全排列,RE数组越界,赛后发现读题读错了,囧! 3 贪心:先确定最高位的数字,然后用贪心的方法,越高位数字越大 4 5 注意:1. Both A and B will have same number of digits 两个数字位数相同 6 2. which is no larger than 10 6 不是大小,而是长度不超过1e6 7 */ 8 #include <cstdio> 9 #include <iostream&g

hdoj 2124 Repair the Wall 【贪心】

题意:有一栋墙坏了(台风吹坏的,并且宽度一定),这个猪脚要修这栋墙,并且找到了一些宽度跟刮坏的墙一样,只是长度不一样的木块,让你求这些木块能不能修好这堵墙, 一句话就是判断这些的木块的长度的和能不能大于破坏的墙的长度,如果能,输出最少用几块, 不能输出impossible. 这道题水的不行...从大到小排下序就好了 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2124 代码: #include<stdio.h> #include<algo

hdoj 3177 Crixalis&#39;s Equipment 【贪心】

Crixalis's Equipment Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 3073    Accepted Submission(s): 1250 Problem Description Crixalis - Sand King used to be a giant scorpion(蝎子) in the deserts

hdoj 1052 Tian Ji -- The Horse Racing【田忌赛马】 【贪心】

思路:先按从小到大排序, 然后从最快的開始比(如果i, j 是最慢的一端, flag1, flag2是最快的一端 ),田的最快的大于king的 则比較,如果等于然后推断,有三种情况: 一:大于则比較,二等于在推断田的最慢的是不是比king的最快的慢,三小于则与king的最快的比較: Tian Ji -- The Horse Racing Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Othe

POJ 2209 The King(简单贪心)

The King Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 7499   Accepted: 4060 Description Once upon a time in a country far away lived a king and he had a big kingdom. He was a very clever king but he had one weakness -- he could count

枚举+贪心 HDOJ 4932 Miaomiao&#39;s Geometry

题目传送门 1 /* 2 题意:有n个点,用相同的线段去覆盖,当点在线段的端点才行,还有线段之间不相交 3 枚举+贪心:有坑点是两个点在同时一条线段的两个端点上,枚举两点之间的距离或者距离一半,尽量往左边放,否则往右边放, 4 判断一下,取最大值.这题二分的内容少 5 */ 6 #include <cstdio> 7 #include <algorithm> 8 #include <cstring> 9 #include <cmath> 10 using n